IMPORT util
TYPE arrRowType RECORD
   group SMALLINT,
   code  SMALLINT,
   sales DECIMAL(11,2),
   costs DECIMAL(11,2)
END RECORD
DEFINE arr DYNAMIC ARRAY OF arrRowType
DEFINE grw om.SaxDocumenthandler

MAIN
DEFINE i INTEGER
   CALL populate_data()

   IF NOT fgl_report_loadCurrentSettings("aftergroup.4rp") THEN
      CALL fgl_report_selectDevice("SVG")
      CALL fgl_report_selectpreview(TRUE)
   END IF

   LET grw = fgl_report_commitCurrentSettings()

   START REPORT group_rpt TO XML HANDLER grw
   FOR i = 1 TO arr.getLength()
      OUTPUT TO REPORT group_rpt(arr[i].*)
   END FOR
   FINISH REPORT group_rpt

END MAIN


REPORT group_rpt(x)
DEFINE x arrRowType
DEFINE grp_sum, lastrow_sum RECORD 
   sales DECIMAL(11,2),
   costs DECIMAL(11,2),
   count INTEGER
END RECORD

ORDER EXTERNAL BY x.group, x.code

FORMAT 
   BEFORE GROUP OF x.group
      PRINTX x.group

   ON EVERY ROW
      PRINTX x.*

   AFTER GROUP OF x.group
      LET grp_sum.sales = GROUP SUM(x.sales)
      LET grp_sum.costs = GROUP SUM(x.costs)
      LET grp_sum.count = GROUP COUNT(*)
      PRINTX grp_sum.*

   ON LAST ROW
      LET lastrow_sum.sales = SUM(x.sales)
      LET lastrow_sum.costs = SUM(x.costs)
      LET lastrow_sum.count= COUNT(*)
      PRINTX lastrow_sum.*

END REPORT

FUNCTION populate_data()
DEFINE g,c SMALLINT
DEFINE g_count, c_count SMALLINT

   LET g_count = 20
   FOR g = 1 TO g_count
      LET c_count = 1 + util.Math.rand(50)
      FOR c = 1 TO c_count
         CALL arr.appendElement()
         LET arr[arr.getLength()].group = g 
         LET arr[arr.getLength()].code = c
         LET arr[arr.getLength()].costs= util.Math.rand(10000) + (util.Math.rand(100)/100)
         LET arr[arr.getlength()].sales= (0.9 + util.Math.rand(10000)/20000) * arr[arr.getLength()].costs
      END FOR
   END FOR
END FUNCTION